file = ReadFile("./settings.ini")
Global gx=ReadLine(file)
Global gy=ReadLine(file)
Global screen=ReadLine(file)
Global skinnr$=ReadLine(file)
CloseFile file

file = ReadFile("./highscore.dat")
Global highscore=ReadLine(file)
CloseFile file


AppTitle "Jumping Jack"
Graphics gx,gy,32,screen

SetBuffer BackBuffer()
SeedRnd MilliSecs()


Global Timer = CreateTimer(30)
Global scrolly=0,points,monsterwarn=0,maxjumpspeed=60,bildy,dietime=40

;----- Types----------
Type doodle
Field x#,y#,dir,jump,jumptime#,falltime#,jumptype#
End Type

Type enemy
Field x,y,typ,angle,dif
End Type

Type block
Field x,y,Typ,speed#,dir
End Type

Type obj
Field x,y,typ
End Type
;-------------------------------------------

;--------------------------LOADING---------------------
Global doodleimg=LoadAnimImage("./Graphics/"+skinnr+"/doodleimg.png",64,64,0,2)
Global blockimg=LoadAnimImage("./Graphics/"+skinnr+"/blockimg.png",32,32,0,2)
Global objimg=LoadAnimImage("./Graphics/"+skinnr+"/objimg.png",32,32,0,2)
Global enemyimg=LoadAnimImage("./Graphics/"+skinnr+"/enemyimg.png",128,128,0,1)
Global bg=LoadImage("./Graphics/"+skinnr+"/bg.png")
Global gameoverimage=LoadImage("./Graphics/gameover.png")
Global gameoverimagemini=LoadImage("./Graphics/gameovermini.png")
Global pfeileimg=LoadAnimImage("./Graphics/pfeile.png",32,32,0,2)
ResizeImage bg,gx,gy
ResizeImage gameoverimage,gx,gy
MaskImage doodleimg,255,0,255
MaskImage blockimg,255,0,255
MaskImage objimg,255,0,255
MaskImage enemyimg,255,0,255
MaskImage pfeileimg,255,0,255
MidHandle doodleimg
MidHandle blockimg
MidHandle objimg
MidHandle enemyimg
MidHandle pfeileimg
MidHandle gameoverimagemini
Global font=LoadFont("Comic Sans MS",24,1,0,0)
Global bigfont=LoadFont("Comic Sans MS",32,1,1,0)
;-----------------------------------------------------
SetFont font

d.doodle = New doodle
d\x=gx/2
d\y=-300
b.block = New block
b\x=gx/2
b\y=0
HidePointer

createlevel()
DrawImage bg,0,0
DrawImage doodleimg,200,gy/2,0
DrawImage blockimg,200,gy/2+128,0
DrawImage pfeileimg,200,gy/2+64,1

DrawImage doodleimg,400,gy/2-64,0
DrawImage objimg,400,gy/2+128,0
DrawImage pfeileimg,400,gy/2+64,1
DrawImage pfeileimg,400,gy/2,1

DrawImage doodleimg,gx-400,gy/2,0
DrawImage gameoverimagemini,gx-400,gy/2+256,0
DrawImage pfeileimg,gx-400,gy/2+64,0
DrawImage pfeileimg,gx-400,gy/2+128,0

DrawImage gameoverimagemini,gx-200,gy/2-256,0
DrawImage pfeileimg,gx-200,gy/2-164,1
DrawImage enemyimg,gx-200,gy/2-64,0
DrawImage doodleimg,gx-200,gy/2+128,0
DrawImage pfeileimg,gx-200,gy/2+64,1



Flip
WaitKey()
FlushKeys()

;---------- MAIN Looooop-----------
While Not KeyHit(1)
Cls
control()
draw()
monsterwarner()
WaitTimer(timer)
Flip
Wend
End



;-----------FUNCTIONS------------------

Function control()
For d.doodle = Each doodle
If KeyDown(205) Then d\x = d\x + 10 : d\dir=1
If KeyDown(203) Then d\x = d\x - 10 : d\dir=0
If d\x < 0 Then d\x = gx-30
If d\x > gx-30 Then d\x = 0


scrolly=d\y-gy/2-gy/6
For b.block = Each block
If ImagesCollide(doodleimg,d\x,d\y,d\dir,blockimg,b\x,b\y,b\Typ) And d\jump=0 Then
Select b\typ
Case 0
d\jump=1
If d\falltime > 20 Then
d\jumptime=d\falltime*2
Else
d\jumptime=Rand(30,50)
EndIf
d\falltime=0
d\jumptype=2
Case 1
d\jump=1
If d\falltime > 20 Then
d\jumptime=d\falltime*2
Else
d\jumptime=Rand(30,50)
EndIf
d\falltime=0
d\jumptype=2
End Select
EndIf
Select b\typ
Case 1
b\x=b\x+b\speed*b\dir
If b\x<0 Then b\x = gx
If b\x>gx Then b\x=0
End Select
Next

For o.obj = Each obj
If ImagesOverlap(doodleimg,d\x,d\y,objimg,o\x,o\y) And d\jump=0 Then
Select o\typ
Case 0
d\jump=1
d\jumptime=100
d\falltime=0
d\jumptype=3
Case 1
d\jump=1
d\jumptime=60
d\falltime=0
d\jumptype=0.2
End Select
EndIf
Next


If d\jumptime > 0 Then
If d\jumptime > maxjumpspeed Then
d\y=d\y-maxjumpspeed
Else
d\y=d\y-d\jumptime
EndIf
d\jumptime=d\jumptime-d\jumptype
Else
If d\falltime < dietime Then
d\jump=0
d\y=d\y+d\falltime
d\falltime=d\falltime+1
Else
gameover()
Exit
EndIf
EndIf

points=d\y*-1

For e.enemy = Each enemy
If ImagesCollide(doodleimg,d\x,d\y,d\dir,enemyimg,e\x,e\y,e\Typ) Then
gameover()
Exit
EndIf
Next

Next
End Function

Function Draw()
Color 255,255,255
DrawImage bg,0,scolly
For e.enemy = Each enemy
DrawImage enemyimg,e\x,e\y-scrolly,e\typ
Next
For b.block = Each block
DrawImage blockimg,b\x,b\y-scrolly,b\typ
Next
For o.obj = Each obj
DrawImage objimg,o\x,o\y-scrolly,o\typ
Next
For d.doodle = Each doodle
DrawImage doodleimg,d\x,d\y-scrolly,d\dir
Text gx/2,0,points,1,0
Next
End Function


Function gameover()
SetFont bigfont
Repeat
Cls
DrawImage gameoverimage,0,0
Color 255,255,255
Text 200,gy-100," "+highscore,1,1
DrawImage doodleimg,gx-256,gy-100,1
Text gx-200,gy-100,"  : "+points,1,1
If points>highscore And go=0Then
Flip
highscore=points
file = WriteFile("./highscore.dat")
WriteLine(file,highscore)
FlushKeys()
CloseFile(file)
go=1
EndIf
If KeyHit(28) Or KeyHit(57) Then
restart()
Exit
ElseIf KeyHit(1) Then
End
EndIf
WaitTimer(timer)
Flip
Forever
End Function

Function restart()
scrolly=300 : points=0
For e.enemy = Each enemy
Delete e
Next
For b.block = Each block
Delete b
Next
For o.obj = Each obj
Delete o
Next
For d.doodle = Each doodle
Delete d
Next
SetFont font
d.doodle = New doodle
d\x=gx/2
d\y=300
b.block = New block
b\x=gx/2
b\y=500
createlevel()
End Function

Function monsterwarner()
If KeyHit(157) Then 
If monsterwarn Then
monsterwarn=0
Else
monsterwarn=1
EndIf
EndIf
If monsterwarn=1 Then
For d.doodle = Each doodle
For e.enemy = Each enemy
e\angle = -(ATan2(d\x-e\x,d\y-e\y))
e\angle = (e\angle+360) Mod 360
e\dif = dif(d\x,e\x,d\y,e\y)
If e\dif < 10000 Then
If e\angle => 0 And e\angle <= 90 Or e\angle => 270 And e\angle <= 360 Then
Color 255,0,0
Rect d\x+(e\dif/5)*Sin(e\angle),d\y-scrolly-(e\dif/10)*Cos(e\angle),10,10
EndIf
EndIf
Next
Next
EndIf
End Function

Function Dif(nr1,nr2,nr3,nr4)
	nr5=Abs(nr1-nr2)
	nr6=Abs(nr3-nr4)
	nr7=nr5+nr6
	Return nr7
End Function

Function createlevel()
;BIS 10000
createblock(20,-100,100,1)
createfeder(-20,-100,100,30)
;BIS 20000
createblock(-100,-200,100,1.25)
createjetpack(-150,-200,100,50)
createenemy(-120,-200,100,50)
createfeder(-120,-200,100,25)
;BIS 40000
createblock(-200,-400,100,1.75)
createmoveblock(-200,-400,100,5)
createfeder(-200,-400,100,30)
createenemy(-200,-400,100,45)
createjetpack(-200,-400,100,60)
;BIS 50000
createmoveblock(-400,-500,100,0.75)
createenemy(-400,-500,100,30)
;BIS 75000
createmoveblock(-500,-750,100,3)
createblock(-500,-750,100,2)
createfeder(-500,-750,100,15)
;BIS 100000
createmoveblock(-750,-1000,100,2)
createblock(-750,-1000,100,5)
createfeder(-750,-1000,100,25)
createjetpack(-750,-1000,100,15)
;BIS 200000
createmoveblock(-1000,-2000,100,4)
createblock(-1000,-2000,100,2)
createfeder(-1000,-2000,100,50)
createjetpack(-1000,-2000,100,75)
createenemy(-1000,-2000,100,40)
;BIS 300000
createmoveblock(-2000,-3000,100,5)
createblock(-2000,-3000,100,2.5)
createfeder(-2000,-3000,100,60)
createjetpack(-2000,-3000,100,95)
createenemy(-2000,-3000,100,30)
;BIS 500000
createmoveblock(-3000,-5000,100,6)
createblock(-3000,-5000,100,3)
createfeder(-3000,-5000,100,75)
createjetpack(-3000,-5000,100,110)
createenemy(-3000,-5000,100,25)
;BIS 1000000
createmoveblock(-5000,-10000,100,8)
createblock(-5000,-10000,100,4)
createfeder(-5000,-10000,100,100)
createjetpack(-5000,-10000,100,200)
createenemy(-5000,-10000,100,15)




End Function


Function createblock(durch#,max,faktor,Stepp#)
;NORMALER BLOCK
Repeat
b.block = New block
b\x=Rand(32,gx-30)
b\y=durch#*faktor
b\typ=0
durch#=durch#-stepp#
Until durch#<=max
End Function

Function createmoveblock(durch#,max,faktor,Stepp#)
;Bewegender BLOCK
Repeat
b.block = New block
b\x=Rand(32,gx-30)
b\y=durch#*faktor
b\typ=1
b\speed=Rnd(0.5,4)
Repeat
b\dir=Rand(-1,1)
Until b\dir <> 0
durch#=durch#-stepp#
Until durch#<=max
End Function

Function createenemy(durch#,max,faktor,Stepp#)
;1ter GEGNER
Repeat
e.enemy = New enemy
e\x=Rand(32,gx-50)
e\y=durch#*faktor
e\typ=0
durch#=durch#-stepp#
Until durch#<=max
End Function

Function createfeder(durch#,max,faktor,Stepp#)
;SPRUNGFEDER
Repeat
o.Obj = New obj
o\x = Rand(128,gx-40)
o\y = durch#*faktor
o\typ = 0
b.block = New block
b\x=o\x-4
b\y=o\y+16
b\typ=0
durch#=durch#-stepp
Until durch#<=max
End Function

Function createjetpack(durch#,max,faktor,stepp#)
;JETPACK
Repeat
o.Obj = New obj
o\x = Rand(128,gx-40)
o\y = durch#*faktor
o\typ = 1
b.block = New block
b\x=o\x-4
b\y=o\y+16
b\typ=0
durch#=durch#-stepp#
Until durch#<=max
End Function